unit Unit1;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QMenus, QTypes, QComCtrls, QExtCtrls, QStdCtrls;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    ControlBar1: TControlBar;
    ComboBox1: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
    Path:String;
    procedure ListDir(dir:String);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.FormShow(Sender: TObject);
begin
 ListDir('/');
end;

procedure TForm1.ListDir(dir: String);
var
  sr: TSearchRec;
begin
 ListView1.Items.Clear;
 if FindFirst(dir+'*', faAnyFile, sr) = 0 then
  begin
   repeat
    ListView1.Items.Add.Caption:=sr.Name;
   until FindNext(sr) <> 0;
    FindClose(sr);
   end;
 Path:=dir;

 if ComboBox1.Items.IndexOf(Path)=-1 then
  ComboBox1.Items.Add(Path);
 if ComboBox1.Items.count>20 then
  ComboBox1.Items.Delete(0);
 ComboBox1.Text:=Path;
end;

procedure TForm1.ListView1DblClick(Sender: TObject);
begin
 if ListView1.Selected.Caption='.' then Path:='/'
 else
  if ListView1.Selected.Caption='..' then
   begin
    path:=copy(Path,1,Length(Path)-1);
    Path:=ExtractFilePath(Path);
   end
  else
   Path:=Path+ListView1.Selected.Caption+'/';
 ListDir(Path);
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
 ListDir(Combobox1.Text);
end;

end.
